﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/Load")]
  [Name("CompactDatabase")]
  [Description("Skrinks the database to free up unused space")]
  public class CompactDatabaseActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty DBEntryProperty = DependencyProperty.Register(
        "DBEntry", typeof (LoadAppLogic.DatabaseEntry), typeof (CompactDatabaseActivity));

    [RequiredInputParam]
    [Name("DBEntry")]
    [Description("Database to compact")]
    public LoadAppLogic.DatabaseEntry DBEntry {
      get { return ((LoadAppLogic.DatabaseEntry)(base.GetValue(CompactDatabaseActivity.DBEntryProperty))); }
      set { base.SetValue(CompactDatabaseActivity.DBEntryProperty, value); }
    }

    #endregion

    #region Output dependency Properties
    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      LoadAppLogic.CompactDatabase(DBEntry);

      return base.Execute(executionContext);
    }
    #endregion
  }
}