﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/Load")]
  [Name("CreateEmptyLoadDB")]
  [Description("Creates an empty Load database instance and returs the DatabaseEntry for it")]
  public class CreateEmptyLoadDBActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty JobIDProperty = DependencyProperty.Register(
        "JobID", typeof(string), typeof(CreateEmptyLoadDBActivity));

    [RequiredInputParam]
    [Name("JobID")]
    [Description("JobID to use as the name of the Load DB instance")]
    public string JobID {
      get { return ((string)(base.GetValue(CreateEmptyLoadDBActivity.JobIDProperty))); }
      set { base.SetValue(CreateEmptyLoadDBActivity.JobIDProperty, value); }
    }

    #endregion

    #region Output dependency Properties

    public static DependencyProperty DBEntryProperty = DependencyProperty.Register(
    "DBEntry", typeof(LoadAppLogic.DatabaseEntry), typeof(CreateEmptyLoadDBActivity));

    [OutputParam]
    [Name("DBEntry")]
    [Description("Database entry representing the newly created Load database instance")]
    public LoadAppLogic.DatabaseEntry DBEntry {
      get { return ((LoadAppLogic.DatabaseEntry)(base.GetValue(CreateEmptyLoadDBActivity.DBEntryProperty))); }
      set { base.SetValue(CreateEmptyLoadDBActivity.DBEntryProperty, value); }
    }


    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      DBEntry = LoadAppLogic.CreateEmptyLoadDB(JobID);

      return base.Execute(executionContext);
    }
    #endregion
  }
}