﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/Shim")]
  [Name("GenericToIListShim")]
  [Description("Converts a generic List<CSVFileEntry> to a IList of CSVFileEntry")]
  public class GenericToIListShimActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty GenericListProperty = DependencyProperty.Register(
        "GenericList", typeof(List<LoadAppLogic.CSVFileEntry>), typeof(GenericToIListShimActivity));

    [RequiredInputParam]
    [Name("GenericList")]
    [Description("Generic List of Objects")]
    public List<LoadAppLogic.CSVFileEntry> GenericList {
      get { return ((List<LoadAppLogic.CSVFileEntry>)(base.GetValue(GenericToIListShimActivity.GenericListProperty))); }
      set { base.SetValue(GenericToIListShimActivity.GenericListProperty, value); }
    }

    #endregion

    #region Output dependency Properties

    public static DependencyProperty NonGenericListProperty = DependencyProperty.Register(
    "NonGenericList", typeof(IList), typeof(GenericToIListShimActivity));

    [OutputParam]
    [Name("NonGenericList")]
    [Description("Input converted to a non-generic list of objects")]
    public IList NonGenericList {
      get { return ((IList)(base.GetValue(GenericToIListShimActivity.NonGenericListProperty))); }
      set { base.SetValue(GenericToIListShimActivity.NonGenericListProperty, value); }
    }

    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      NonGenericList = GenericList;

      return base.Execute(executionContext);
    }
    #endregion
  }
}