﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/PreLoad")]
  [Name("IsCSVReadyFileExists")]
  [Description("Checks if the CSV Ready File exists in the given rooth path to the CSV Batch")]
  public class IsCSVReadyFileExistsActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty CSVRootPathProperty = DependencyProperty.Register(
        "CSVRootPath", typeof (string), typeof (IsCSVReadyFileExistsActivity));

    [RequiredInputParam]
    [Name("CSVRootPath")]
    [Description("Path to the root directory for the batch")]
    public string CSVRootPath {
      get { return ((string)(base.GetValue(IsCSVReadyFileExistsActivity.CSVRootPathProperty))); }
      set { base.SetValue(IsCSVReadyFileExistsActivity.CSVRootPathProperty, value); }
    }

    #endregion

    #region Output dependency Properties

    public static DependencyProperty IsExistsProperty =
        DependencyProperty.Register("IsExists", typeof (bool), typeof (IsCSVReadyFileExistsActivity));

    [OutputParam]
    [Name("IsExists")]
    [Description("true if the csv_ready.csv file exists in the CSVRoothPath. False otherwise.")]
    public bool IsExists {
      get { return ((bool)(base.GetValue(IsCSVReadyFileExistsActivity.IsExistsProperty))); }
      set { base.SetValue(IsCSVReadyFileExistsActivity.IsExistsProperty, value); }
    }
    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      IsExists = LoadAppLogic.IsCSVReadyFileExists(CSVRootPath);

      return base.Execute(executionContext);
    }
    #endregion
  }
}