﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/PreLoad")]
  [Name("IsExistsCSVFile")]
  [Description("Test if a CSV File defined in the CSV Ready list actually exists on disk.")]
  public class IsExistsCSVFileActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty FileEntryProperty =
        DependencyProperty.Register("FileEntry", typeof (LoadAppLogic.CSVFileEntry),
                                    typeof (IsExistsCSVFileActivity));

    [RequiredInputParam]
    [Name("CSVFileEntry")]
    [Description("FileEntry for CSVFile to test")]
    public LoadAppLogic.CSVFileEntry FileEntry {
      get { return ((LoadAppLogic.CSVFileEntry)(base.GetValue(IsExistsCSVFileActivity.FileEntryProperty))); }
      set { base.SetValue(IsExistsCSVFileActivity.FileEntryProperty, value); }
    }


    #endregion

    #region Output dependency Properties

    public static DependencyProperty IsExistsProperty =
        DependencyProperty.Register("IsExists", typeof (bool), typeof (IsExistsCSVFileActivity));

    [OutputParam]
    [Name("IsExists")]
    [Description("True if the FilePath in the given FileEntry exists on disk. False otherwise.")]
    public bool IsExists {
      get { return ((bool)(base.GetValue(IsExistsCSVFileActivity.IsExistsProperty))); }
      set { base.SetValue(IsExistsCSVFileActivity.IsExistsProperty, value); }
    }
    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      IsExists = LoadAppLogic.IsExistsCSVFile(FileEntry);

      return base.Execute(executionContext);
    }
    #endregion
  }
}