﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/PreLoad")]
  [Name("IsMatchCSVFileColumnNames")]
  [Description("Checks if the correct list of column headers is present for the CSV file to match the table")]
  public class IsMatchCSVFileColumnNamesActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty FileEntryProperty =
        DependencyProperty.Register("FileEntry", typeof (LoadAppLogic.CSVFileEntry),
                                    typeof (IsMatchCSVFileColumnNamesActivity));

    [RequiredInputParam]
    [Name("CSVFileEntry")]
    [Description("FileEntry for CSV File whose column headers to test")]
    public LoadAppLogic.CSVFileEntry FileEntry {
      get { return ((LoadAppLogic.CSVFileEntry)(base.GetValue(IsMatchCSVFileColumnNamesActivity.FileEntryProperty))); }
      set { base.SetValue(IsMatchCSVFileColumnNamesActivity.FileEntryProperty, value); }
    }


    #endregion

    #region Output dependency Properties

    public static DependencyProperty IsMatchProperty =
        DependencyProperty.Register("IsMatch", typeof(bool), typeof(IsMatchCSVFileColumnNamesActivity));

    [OutputParam]
    [Name("IsMatch")]
    [Description("True if the column headers present in the CSV File are the same as the expected table columns. False otherwise.")]
    public bool IsMatch {
      get { return ((bool)(base.GetValue(IsMatchCSVFileColumnNamesActivity.IsMatchProperty))); }
      set { base.SetValue(IsMatchCSVFileColumnNamesActivity.IsMatchProperty, value); }
    }
    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      IsMatch = LoadAppLogic.IsMatchCSVFileColumnNames(FileEntry);

      return base.Execute(executionContext);
    }
    #endregion
  }
}