﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory( "PC3/PreLoad" )]
  [Name("IsMatchCSVFileTables")]
  [Description("Check if the correct list of files/table names are present in this batch")]
  public class IsMatchCSVFileTablesActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty FileEntriesProperty =
        DependencyProperty.Register("FileEntries", typeof (List<LoadAppLogic.CSVFileEntry>),
                                    typeof (IsMatchCSVFileTablesActivity));

    [RequiredInputParam]
    [Name("CSVFileEntries")]
    [Description("List of CSV File entries to check against tables")]
    public List<LoadAppLogic.CSVFileEntry> FileEntries {
      get { return ((List<LoadAppLogic.CSVFileEntry>)(base.GetValue(IsMatchCSVFileTablesActivity.FileEntriesProperty))); }
      set { base.SetValue(IsMatchCSVFileTablesActivity.FileEntriesProperty, value); }
    }
    #endregion

    #region Output dependency Properties

    public static DependencyProperty IsMatchProperty =
        DependencyProperty.Register("IsMatch", typeof (bool), typeof (IsMatchCSVFileTablesActivity));

    [OutputParam]
    [Name("IsMatch")]
    [Description("true if all expected files and tables match. false otherwise.")]
    public bool IsMatch {
      get { return ((bool)(base.GetValue(IsMatchCSVFileTablesActivity.IsMatchProperty))); }
      set { base.SetValue(IsMatchCSVFileTablesActivity.IsMatchProperty, value); }
    }
    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      IsMatch = LoadAppLogic.IsMatchCSVFileTables(FileEntries);

      return base.Execute(executionContext);
    }
    #endregion
  }
}