﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/PreLoad")]
  [Name("WorkflowInput")]
  [Description("Inputs to the workflow")]
  public class LoadWorkflowInputActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty InCSVRootPathProperty = DependencyProperty.Register(
        "InCSVRootPath", typeof(string), typeof(LoadWorkflowInputActivity));

    public static DependencyProperty InJobIDProperty = DependencyProperty.Register(
        "InJobID", typeof(string), typeof(LoadWorkflowInputActivity));

    [RequiredInputParam]
    [Name("CSVRootPath_In")]
    [Description("Path to the root directory for the batch")]
    public string InCSVRootPath {
      get { return ((string)(base.GetValue(LoadWorkflowInputActivity.InCSVRootPathProperty))); }
      set { base.SetValue(LoadWorkflowInputActivity.InCSVRootPathProperty, value); }
    }

    [RequiredInputParam]
    [Name("JobID_In")]
    [Description("Unique ID for the CSV job/batch to load")]
    public string InJobID {
      get { return ((string)(base.GetValue(LoadWorkflowInputActivity.InJobIDProperty))); }
      set { base.SetValue(LoadWorkflowInputActivity.InJobIDProperty, value); }
    }

    #endregion

    #region Output dependency Properties

    public static DependencyProperty OutCSVRootPathProperty = DependencyProperty.Register(
    "OutCSVRootPath", typeof(string), typeof(LoadWorkflowInputActivity));

    public static DependencyProperty OutJobIDProperty = DependencyProperty.Register(
    "OutJobID", typeof(string), typeof(LoadWorkflowInputActivity));

    [OutputParam]
    [Name("CSVRootPath_Out")]
    [Description("Path to the root directory for the batch")]
    public string OutCSVRootPath {
      get { return ((string)(base.GetValue(LoadWorkflowInputActivity.OutCSVRootPathProperty))); }
      set { base.SetValue(LoadWorkflowInputActivity.OutCSVRootPathProperty, value); }
    }

    [OutputParam]
    [Name("JobID_Out")]
    [Description("Unique ID for the CSV job/batch to load")]
    public string OutJobID {
      get { return ((string)(base.GetValue(LoadWorkflowInputActivity.OutJobIDProperty))); }
      set { base.SetValue(LoadWorkflowInputActivity.OutJobIDProperty, value); }
    }

    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      OutCSVRootPath = InCSVRootPath;
      OutJobID = InJobID;

      return base.Execute(executionContext);
    }
    #endregion
  }
}