﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/Shim")]
  [Name("ObjectToCSVFileEntryShim")]
  [Description("Casts an 'object' to a CSVFileEntry")]
  public class ObjectToCSVFileEntryShimActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty TheObjectProperty = DependencyProperty.Register(
        "TheObject", typeof(object), typeof(ObjectToCSVFileEntryShimActivity));

    [RequiredInputParam]
    [Name("TheObject")]
    [Description("Object of type CSVFileEntry")]
    public object TheObject {
      get { return ((List<LoadAppLogic.CSVFileEntry>)(base.GetValue(ObjectToCSVFileEntryShimActivity.TheObjectProperty))); }
      set { base.SetValue(ObjectToCSVFileEntryShimActivity.TheObjectProperty, value); }
    }

    #endregion

    #region Output dependency Properties

    public static DependencyProperty TheCSVFileEntryProperty = DependencyProperty.Register(
    "TheCSVFileEntry", typeof(LoadAppLogic.CSVFileEntry), typeof(ObjectToCSVFileEntryShimActivity));

    [OutputParam]
    [Name("TheCSVFileEntry")]
    [Description("Input object cast as CSVFileEntry")]
    public LoadAppLogic.CSVFileEntry TheCSVFileEntry {
      get { return ((LoadAppLogic.CSVFileEntry)(base.GetValue(ObjectToCSVFileEntryShimActivity.TheCSVFileEntryProperty))); }
      set { base.SetValue(ObjectToCSVFileEntryShimActivity.TheCSVFileEntryProperty, value); }
    }

    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      TheCSVFileEntry = (LoadAppLogic.CSVFileEntry)TheObject;

      return base.Execute(executionContext);
    }
    #endregion
  }
}