﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/PreLoad")]
  [Name("ReadCSVFileColumnNames")]
  [Description("Reads the header line of the file entry to extract and populate the column names in the CSV File Entry")]
  public class ReadCSVFileColumnNamesActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty InFileEntryProperty =
        DependencyProperty.Register("InFileEntry", typeof(LoadAppLogic.CSVFileEntry),
                                    typeof(ReadCSVFileColumnNamesActivity));

    [RequiredInputParam]
    [Name("CSVFileEntry_In")]
    [Description("CSV File entry whose header file to read column names for")]
    public LoadAppLogic.CSVFileEntry InFileEntry {
      get { return ((LoadAppLogic.CSVFileEntry)(base.GetValue(ReadCSVFileColumnNamesActivity.InFileEntryProperty))); }
      set { base.SetValue(ReadCSVFileColumnNamesActivity.InFileEntryProperty, value); }
    }


    #endregion

    #region Output dependency Properties

    public static DependencyProperty OutFileEntryProperty =
        DependencyProperty.Register("OutFileEntry", typeof(LoadAppLogic.CSVFileEntry),
                                    typeof(ReadCSVFileColumnNamesActivity));

    [OutputParam]
    [Name("CSVFileEntry_Out")]
    [Description("Updated CSV File entry whose column names are populated")]
    public LoadAppLogic.CSVFileEntry OutFileEntry {
      get { return ((LoadAppLogic.CSVFileEntry)(base.GetValue(ReadCSVFileColumnNamesActivity.OutFileEntryProperty))); }
      set { base.SetValue(ReadCSVFileColumnNamesActivity.OutFileEntryProperty, value); }
    }
    #endregion

    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      OutFileEntry = LoadAppLogic.ReadCSVFileColumnNames(InFileEntry);

      return base.Execute(executionContext);
    }
    #endregion
  }
}