﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Linq;
using System.Text;
using info.ipaw.pc3.PSLoadWorkflow;
using ScientificWorkflow;


namespace Microsoft.Research.eResearch.PC3.Activity {
  [WorkflowCategory("PC3/PreLoad")]
  [Name("ReadCSVReadyFile")]
  [Description( "Reads the CSV Ready file and returns the list of file entries" )]
  public class ReadCSVReadyFileActivity : System.Workflow.ComponentModel.Activity {

    #region Input Dependency Properties

    public static DependencyProperty CSVRootPathProperty =
        DependencyProperty.Register("CSVRootPath", typeof (string),
                                    typeof (ReadCSVReadyFileActivity));

    [RequiredInputParam]
    [Name("CSVRootPath")]
    [Description("Path to the root directory for the batch")]
    public string CSVRootPath {
      get { return ((string)(base.GetValue(ReadCSVReadyFileActivity.CSVRootPathProperty))); }
      set { base.SetValue(ReadCSVReadyFileActivity.CSVRootPathProperty, value); }
    }

    #endregion

    #region Output dependency Properties

    public static DependencyProperty FileEntriesProperty =
        DependencyProperty.Register("FileEntries", typeof (List<LoadAppLogic.CSVFileEntry>),
                                    typeof (ReadCSVReadyFileActivity));

    [OutputParam]
    [Name("CSVFileEntries")]
    [Description("List of CSV file entries present in the ready file")]
    public List<LoadAppLogic.CSVFileEntry> FileEntries {
      get { return ((List<LoadAppLogic.CSVFileEntry>)(base.GetValue(ReadCSVReadyFileActivity.FileEntriesProperty))); }
      set { base.SetValue(ReadCSVReadyFileActivity.FileEntriesProperty, value); }
    }
    #endregion

    public ReadCSVReadyFileActivity () {}


    #region Execution
    protected override ActivityExecutionStatus Execute( ActivityExecutionContext executionContext ) {

      FileEntries = LoadAppLogic.ReadCSVReadyFile(CSVRootPath);

      return base.Execute(executionContext);
    }
    #endregion
  }
}